
Import mojo2

#GLFW_WINDOW_TITLE				= "Mojo2 Tester"
#MOJO_IMAGE_FILTERING_ENABLED	= False

Const SCALE:Float = 0.5 ' Change this for scaling effects! Try 0.5, 0.25, etc...
	
Class Game Extends App

	' Main display canvas...
	
	Field display:Canvas
	
	' Images...
	
	Field boing:Image
	Field background:Image
	
	' Render-target Image and associated Canvas... this will be scaled by SCALE global, above...
	
	Field rendertarget:Image
	Field renderbuffer:Canvas
	
	' Mouse X/Y...
	
	Field mx:Int, my:Int
	
	Method OnCreate ()
			
		' Main display canvas...
		
		display			= New Canvas		
		display.SetProjection2d 0.0, display.Width * SCALE, 0.0, display.Height * SCALE

		' Load images...
		
		boing			= Image.Load ("boing.png", 0.5, 0.5, 0)
		background		= Image.Load ("background.png", 0.0, 0.0, 0)
		
		' Scaled render target...
		
		rendertarget	= New Image (display.Width * SCALE, display.Height * SCALE, 0.0, 0.0, 0)
		renderbuffer	= New Canvas (rendertarget)
		renderbuffer.SetProjection2d 0, display.Width, 0, display.Height
		
	End
	
	Method OnUpdate ()
	
		If KeyHit (KEY_ESCAPE) Then Error ""

		mx = MouseX ()
		my = MouseY ()
		
	End
	
	Method OnRender ()
	
		' Draw to scaled render target...
		
		renderbuffer.Clear
		renderbuffer.DrawImage background, 0, 0
		renderbuffer.DrawImage boing, MouseX (), MouseY (), 0.0, 0.5, 0.5
		renderbuffer.Flush
		
		' Draw render target to main display...
		
		display.Clear
		display.DrawImage rendertarget, 0.0, 0.0
		display.DrawText "Scale: " + SCALE, 0, 0
		display.Flush
		
	End
	
End

Function Main ()
	New Game
End
